package org.dromara.mall.promotion.service;

import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.mall.promotion.domain.bo.MallBargainBo;
import org.dromara.mall.promotion.domain.vo.MallBargainVo;

import java.util.Collection;
import java.util.List;

/**
 * 砍价活动Service接口
 *
 * @author pengles
 */
public interface MallBargainService {

    /**
     * 查询砍价活动
     */
    MallBargainVo queryById(Long id);

    /**
     * 查询砍价活动列表
     */
    TableDataInfo<MallBargainVo> queryPageList(MallBargainBo bo, PageQuery pageQuery);

    /**
     * 查询砍价活动列表
     */
    List<MallBargainVo> queryList(MallBargainBo bo);

    /**
     * 查询可用的砍价活动列表（移动端）
     */
    List<MallBargainVo> queryAvailableList();

    /**
     * 根据SKU ID查询砍价活动
     */
    MallBargainVo queryBySkuId(Long skuId);

    /**
     * 新增砍价活动
     */
    Boolean insertByBo(MallBargainBo bo);

    /**
     * 修改砍价活动
     */
    Boolean updateByBo(MallBargainBo bo);

    /**
     * 校验并批量删除砍价活动信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 启用/禁用砍价活动
     */
    Boolean changeStatus(Long id, Integer status);

}
